import sys
sys.path = [ "./", "./modules", "./jelizapy/lib/", "./lib/", "./jelizapy/lib-dynload", "bin" ] + sys.path
sys.argv = [ "./kernel.exe" ]
print sys.path

try:
    sys.winver
    print 'Psyco: Windows'
    """ Laeuft auf Windows """
    import psycowin as psyco
    psyco.log()
    psyco.full(memory=700)
except:
    print 'Psyco: Linux'
    try:
        import psyco_linux as psyco
        psyco.log()
        psyco.full(memory=700)
    except:
        print 'Cannot activate Psyco'


from utilities import *
from defs import loadcache
from jelizacpp import *
from threading import *
true = True
false = False
loadcache()

from modules.defs import *

db = []

funcs_module = []
funcs_before = []
funcs_after = []
funcs_idle = []
funcs_init = []
funcs_background = []

fp = open("modules/index.cfg")
mods = fp.read().strip().split("\n")
fp.close()
for mod in mods:
    log("- Module: " + mod)
    mod = mod.strip()
    if len(mod) > 0:
        exec(open("modules/" + mod + ".py").read())


class background_do(Thread):
    def __init__ (self, func, db):
           Thread.__init__(self)
           self.func = func
           self.db = db
    def run(self):
          self.func(self.db)


def exec_modules(num, question, orig_question):
    try:
        fp = open("temp/pyjdb.py", "r")
        exec(fp.read())
        fp.close()

        db_orig = db + []

    except:
        time.sleep(1)
        fp = open("temp/pyjdb.py", "r")
        exec(fp.read())
        fp.close()
        db_orig = db + []

    for func in funcs_before:
        db = db_orig + []
        func(question, orig_question, db)

    for func in funcs_module:
        db = db_orig + []

        try:
            ans = func(question, orig_question, db)
            ans = str(ans)
            if len(ans) > 0:
                return ans
        except KeyError:
            print
            print
            print "KEYERROR"
            print
            print
            raise
            return ""


class IdleThread(Thread):
    func = None
    db = None
    stop_it = None

    def setFunc(self, func, db, stop_it):
        self.func = func
        self.db = db
        self.stop_it = stop_it

    def run(self):
        self.func(self.db, self.stop_it)


def display_history(his, oldhis):
#    if his != oldhis:

    print "DISPLAY:", his

    display("<br>".join(his))
    from time import sleep

    oldhis = []
    oldhis += [ hi.strip() for hi in his ]

def loop():
    history = []
    oldhis = []

    stop_it = False

    exec(open("temp/pyjdb.py").read())
    for func in funcs_init:
        func(db, stop_it)

    is_ready = True
    threads_to_join = []

    for func in funcs_background:
        thread = background_do(func, db)
        thread.start()

    num = 0
    while True:
        cpp_update_procent(0)

        while not is_ready:
            time.sleep(1)

        is_ready = False

        num += 1
        fra = ""

        hook = ""
        try:
            fp = open("temp/clear_talking.tmp")
            hook = fp.read().strip()
            fp.close()
        except:
            pass
        if len(hook) > 0:
            fp = open("temp/clear_talking.tmp", "w")
            fp.close();
            history = []
#            display_history(history, [])
            oldhis = []


        try:
            fp = open("temp/new_sentence.tmp")
            fra = fp.read().strip()
            fp.close()
        except:
            pass
        if len(fra) > 0:
            fp = open("temp/new_sentence.tmp", "w")
            fp.close()

            num = 0

            stop_it = True

            if fra == "!!init":
                old_stop_it = not (not stop_it)
                stop_it = False
                exec(open("temp/pyjdb.py").read())
                for func in funcs_init:
                    func(db, stop_it)
                continue
                stop_it = old_stop_it


            stop_it = True

            orig_fra = cpp_transformation(fra)
            orig_fra, fra = fra, orig_fra

            from utilities import split_subclause, correct_time
            s_fra = saetze_einzeln(expand_ausdruecke(fra), True)[:]
            s_orig_fra = saetze_einzeln(expand_ausdruecke_orig(orig_fra), False)[:]

            q = 0
            answeren = []
            if len(s_orig_fra) > 1:
                for o in s_orig_fra[1]:
                    for oo in split_subclause(o)[1]:
                        print "Learn:", oo
                        oo = correct_time(oo)
                        cpp_learn(o)
            exec(open("temp/pyjdb.py").read())
            for func in funcs_after:
                func(db, stop_it)
            while q < len(s_fra[0]) and q < len(s_orig_fra[0]):
                print "s_fra", s_fra
                if not len(s_fra[0][q]):
                    q += 1
                    continue
                f = expand_ausdruecke(split_subclause(s_fra[0][q])[0])
                orig_f = expand_ausdruecke_orig(split_subclause(s_orig_fra[0][q])[0])
                print "f", f
                print "orig_f", orig_f

                if not len(f):
                    q += 1
                    continue

                answeren += exec_modules(num, f, orig_f).split("\n")

                q += 1
            print answeren

            cpp_say(". ".join(answeren))
            for o in orig_fra.split("."):
                o = o.strip()
                if len(o):
                    history.append("<b>Mensch::</b> " + o)
            _answeren = answeren[:]
            answeren = [ "" ]
            pre = ""
            for ant in _answeren:
                if len(ant) > 3:
                    answeren.append(pre.strip() + " " + ant)
                    pre = ""
                else:
                    pre += ant + ". "
            if len(pre) > 0:
                if len(answeren) > 0:
                    answeren[-1] += pre.strip()
                else:
                    answeren.append(pre.strip())
            if len(answeren):
                while len(answeren[0].strip()) == 0 and len(answeren) > 1:
                    answeren.remove(answeren[0])
            history += [ "<b>JEliza::</b> " + ant.strip().replace(":", ":::") for ant in answeren if len(ant.strip()) > 0 ]
            print history
            display_history(history, [])
            time.sleep(2)

            for o in s_orig_fra[0]:
                so = split_subclause(o)
                for oo in [so[0]] + so[1]:
                    oo = expand_ausdruecke_orig(oo)
                    oo = correct_time(oo)

                    cpp_learn(oo)


            exec(open("temp/pyjdb.py").read())
            for func in funcs_after:
                func(db, stop_it)

            if num % 180 == 0:
                stop_it = False
                for func in funcs_idle:
                    a = IdleThread()
                    a.setFunc(func, db, stop_it)
                    a.start()


        is_ready = True

        time.sleep(1)



loop()


