# Semantic Network stuff

from defs import get_lang
from utilities import apply_procent


nouns = {}
verbs = {}
noun_verb = {}


fp = open("lang_" + get_lang() + "/wsh/synonyms_verbs.wsh", "r")
verb_lines = fp.readlines()
fp.close()
synonyms_verbs = {}
for line in verb_lines:
    line = line.strip()
    if len(line) > 0:
        line = line.split(" ")

        for x in line:
            for y in line:
                if x != y:
                    try:
                        synonyms_verbs[x[:]]
                    except KeyError:
                        synonyms_verbs[x[:]] = []
                    try:
                        synonyms_verbs[y[:]]
                    except KeyError:
                        synonyms_verbs[y[:]] = []
                    synonyms_verbs[x[:]].append(y[:])
                    synonyms_verbs[y[:]].append(x[:])

def acc(arr, i, d = None):
    u = str(i).lower()
    if u in arr:
        return arr[u]
    if d:
        arr[u] = d
    return d

def acc_int(arr, i, d = None):
    if i < len(arr):
        return arr[i]
    return d

def set_acc(arr, i, o):
    arr[str(i).lower()] = o
    return o

def getUniqValues(dic):
    unique = {} # dictionary
    for item in dic:
        unique[item] = 1
    mylist=unique.keys()
    mylist.sort()
    return mylist

already_in_synonyms_verbs = {}

def verb_synonyms(verb):
    verb = str(verb).lower().strip()
    ret = [verb[:]]
    try:
        ret += synonyms_verbs[verb]
    except KeyError:
        ''''''

#    try:
#        already_in_synonyms_verbs[verb]
#
#        return ret
#    except:
#        ''''''

    a = 0

    copy_ret = ret[:] + [verb]
    for v in copy_ret:
        a += 1
#        apply_procent(0.5 * float(a))
        if v.endswith("tzt"):
            q = v.replace("tzt", "")
            ret.append(q + "tze")
            ret.append(q + "tzst")
            ret.append(q + "tzte")
            ret.append(q + "tztst")
            ret.append(q + "tzen")
            ret.append(q + "tzten")
        if v.endswith("sse"):
            q = v.replace("sse", "")
            ret.append(q + "sst")
            ret.append(q + "ssst")
            ret.append(q + "st")
            ret.append(q + "ssen")
        if v.endswith("en"):
            q = v.replace("en", "")
            ret.append(q + "st")
            ret.append(q + "t")
            ret.append(q + "sst")
            ret.append(q + "tst")
            ret.append(q + "e")
            ret.append(q + "est")
            ret.append(q + "ste")
            ret.append(q + "en")
        for tmp in ("te", "t", "e", "st", "n", "sst"):
            if v.endswith(tmp):
                q = v.replace(tmp, "")
                ret.append(q + "test")
                ret.append(q + "ten")
                ret.append(q + "en")
                ret.append(q + "tst")
                ret.append(q + "t")
                ret.append(q + "e")
                ret.append(q + "st")
                ret.append(q + "sst")
                ret.append(q + "tst")
                ret.append(q + "n")
#    apply_procent(2.5)
    ret = getUniqValues(ret)
#    apply_procent(10)

#    already_in_synonyms_verbs[verb] = True
#    synonyms_verbs[verb] = ret

    return ret




anything = "_"

anything_verb_objects = {}
anything_verb_advs = []


class Relation:
    def __init__(self, id, transitive=1, inverse=None ):
        self.id = id

        # a relation @ is transitive if
        # A @ B and B @ C implies A @ C
        self.transitive = transitive

        if inverse:
            self.inverse = inverse
            inverse.inverse = self
        else:
            self.inverse = None

    def __str__(self):
        return self.id

    def __call__(self, agent, object=None, prio = 50):
        # when used as a function, check to see whether
        # this relation applies
        if not agent:
            return 0


        apply_procent(10)
        tmp = [ str(a[2]) for a in anything_verb_objects.values() if a[0] == self and (a[1] == object or a[1] == agent) ]
        apply_procent(15)
        print "CALL", agent, ",", object, ",", self, ":", tmp
        apply_procent(20)
        if (str(agent) == "_" or str(object) == "_") and len(tmp):
            return " ".join(tmp)
        apply_procent(21)
        tmp = [ str(a[1]) for a in anything_verb_objects.values() if a[0] == self and (a[2] == agent or a[2] == object) ]
        apply_procent(25)
#        print [ a for a in anything_verb_objects.values() if a[0] == self and (a[2] == agent or a[2] == object) ]
        apply_procent(30)
        print "CALL", agent, ",", object, ",", self, ":", tmp
        if (str(agent) == "_" or str(object) == "_") and len(tmp):
            return " ".join(tmp)

        apply_procent(35)
        tmp = [ str(a[1]) for a in anything_verb_objects.values() if a[0] == self and (a[1] == object or a[1] == agent) ]
        apply_procent(38)
        print "CALL", agent, ",", object, ",", self, ":", tmp
        if (str(agent) == "_" or str(object) == "_") and len(tmp):
            return " ".join(tmp)
        apply_procent(50)
        tmp = [ str(a[2]) for a in anything_verb_objects.values() if a[0] == self and (a[2] == agent or a[2] == object) ]
        apply_procent(60)
        print "CALL", agent, ",", object, ",", self, ":", tmp
        if (str(agent) == "_" or str(object) == "_") and len(tmp):
            return " ".join(tmp)

        apply_procent(70)
        obs = agent.getObjects(self, prio)
        obs2 = []
        for o in obs:
            try:
                o = object.split("|")[0]
            except: pass
            obs2.append(o)
        apply_procent(90)
        if not object: return 0
        if not obs or (object not in obs and object not in obs2): return 0
        else: return 1

class fact:
    def __init__(self, _agent, relation, _object, prio = 50, sub = None, advs = []):
        agent = acc(nouns, _agent, Entity(_agent))
        _object = [ o.strip() for o in _object ]
        object = [ acc(nouns, o, Entity(o)) for o in _object ]

        str_relation = str(relation)
        relation = acc(verbs, str_relation)
        if not relation:
            relation = acc(verbs, str_relation, Relation(str_relation))

        self.agent = agent
        self.relation = relation
        self.object = object

        advs = [ a for a in advs if len(str(a)) != 0 ]
        if len(advs) > 0:
            agent.get_list_advs().append((str_relation, advs))
            for o in object:
                o.get_list_advs().append((str_relation, advs))
            anything_verb_advs.append((str_relation, advs))

        try:
            agent.get_list_subs()[str_relation]
        except:
            agent.get_list_subs()[str_relation] = []
        try:
            anything.get_list_subs()[str_relation]
        except:
            anything.get_list_subs()[str_relation] = []

        for o in object:
            try:
                o.get_list_subs()[str_relation]
            except:
                o.get_list_subs()[str_relation] = []

        if sub:
            for s in sub:
                if s not in agent.get_list_subs()[str_relation]:
                    agent.get_list_subs()[str_relation].append(s)
                if s not in anything.get_list_subs()[str_relation]:
                    anything.get_list_subs()[str_relation].append(s)

                for o in object:
                    if s not in o.get_list_subs()[str_relation]:
                        o.get_list_subs()[str_relation].append(s)

        for o in object:
            # stuff into dictionaries, for searching
            agent.storeObject(relation, o, prio)
            o.storeAgent(relation, agent, prio)
            key = " ".join((str(relation), str(o), str(agent)))
            try:
                anything_verb_objects[key]
            except:
                anything_verb_objects[key] = []
            anything_verb_objects[key] += (relation, o, agent)

            # deduce inverse relations as well
            if relation.inverse:
                o.storeObject(relation.inverse, agent, prio)
                agent.storeAgent(relation.inverse.inverse, o, prio)
                key = " ".join((str(relation.inverse), str(o), str(agent)))
                try:
                    anything_verb_objects[key]
                except:
                    anything_verb_objects[key] = []
                anything_verb_objects[key] += (relation.inverse, o, agent)

import re
enthaelt_pipe = re.compile("|")

def Fact(__agent, relation, ___object, prio = 50, sub = None, advs = []):
    _agent = __agent.split("|")
    a = [ "|".join(_agent) ]
    if enthaelt_pipe.search(__agent):
        a.append(_agent[0])
    for agent in a:
        if not len(agent):
            continue

        b = []
        for __object in ___object:
            _object = __object.split("|")
            b.append("|".join(_object).strip())
            if enthaelt_pipe.search(__object):
                b.append(_object[0].strip())

        fact(agent, relation, b, prio, sub, advs)
#    fact(__agent, relation, ___object, prio, sub, advs)



# declare global "is-a" relationship.
# other modules MUST properly use this, rather than
# define their own "is-a", since it has special meaning (inheritance).

list_IS_A = [
             Relation("sein", 1),
             Relation("ist", 1),
             Relation("bin", 1),
             Relation("sind", 1),
             Relation("seid", 1),

             Relation("am", 1),
             Relation("are", 1),
             Relation("is", 1),
             Relation("be", 1),
            ]

# functions to allow outside access to these objects more easily:
def GetIsA(): return list_IS_A[0]

class Entity:
    priority = 50
    subs = {}
    advs = {}

    def __init__(self,id):
        self.id = str(id)
        self.mObjects = { 50: {}, 100: {} }
        self.mAgents = { 50: {}, 100: {} }
        self.relations = {}
        self.subs[self.id] = {}
        self.advs[self.id] = []

    def get_list_subs(self):
        return self.subs[self.id]
    def get_list_advs(self):
        return self.advs[self.id]

    def __str__(self):
        return self.id

    def get_advs(self, rel):
        try:
            r = []
            for (rel_str, advs) in self.advs[self.id]:
#                print "rel_str:", rel_str, rel
                if str(rel_str) == str(rel):
                    r += [ str(n) for n in advs ]
#                    print "r:", r
#            print "r::::", r
            return r
        except KeyError:
            return [ ]

    def objects(self, relation, y = 1, prio = 50, first = ""):
        if id == first:
            return []
        if not len(first):
            first = str(self)

        ans = []
        try: ans += self.mObjects[prio][relation]
        except:
            ans = []
            return ans

        if self.id == "_":
            ans += [ a[1] for a in anything_verb_objects.values() if len(a) > 1 and a[0] == str(relation) ]

#        try: ans += self.mObjects[prio][ADVBB]
#        except: pass

        print "objects:", [id], [str(relation)], [ str(x) for x in ans ]

        y = y + 1
        if y > 4:
            return []

        if relation.transitive and y <= 5:
            # if it's a transitive relation,
            # pursue recursively
            ans_search_in = ans[:]
            for i in ans_search_in:
                if str(i) != str(self):
                    ans = ans + i.objects(relation, y, prio, first)
                    ans_search_in = ans_search_in + i.objects(relation, y, prio, first)
                    for isa in list_IS_A:
                        if str(isa) != str(relation):
                            ans_search_in += i.objects(isa, y, prio, first)
        return ans

    def agents(self,relation, y = 1, prio = 50, first = ""):
        if id == first:
            return []
        if not len(first):
            first = str(self)

        ans = []
        try: ans += self.mAgents[prio][relation]
        except:
            ans = []
            return ans
#        try: ans += self.mAgents[prio][ADVBB]
#        except: pass

        y = y + 1
        if y > 4:
            return []

        if relation.inverse and relation.inverse.transitive and y <= 5:
            # if its inverse is a transitive relation,
            # pursue recursively
            ans_search_in = ans[:]
            for i in ans_search_in:
                if str(i) is not str(self):
                    ans = ans + i.agents(relation, y, prio, first)
                    ans_search_in = ans_search_in + i.agents(relation, y, prio, first)
                    for isa in list_IS_A:
                        ans_search_in += i.agents(isa, y, prio, first)
        return ans

    def storeObject(self,relation,object, prio = 50):
        try:
            self.mObjects[prio]
        except:
            self.mObjects[prio] = {}
        try:
            lst = self.mObjects[prio][relation]
            if object not in lst and object is not self and str(object) is not str(self): lst.append(object)
        except:
            self.mObjects[prio][relation] = [object]

    def storeAgent(self,relation,agent, prio = 50):
        try:
            self.mAgents[prio]
        except:
            self.mAgents[prio] = {}
        try:
            lst = self.mAgents[prio][relation]
            if agent not in lst and object is not self and str(object) is not str(self): lst.append(agent)
        except:
            self.mAgents[prio][relation] = [agent]

    # Get all the objects of a particular relation,
    # where this (self) is the agent.  These are cumulative.
    # Note that there is no way currently for a subclass to
    # override a base class; it can only extend it.
    def getObjects(self,relation, y = 1, first = ""):
        if id == first:
            return []
        if not len(first):
            first = str(self)

        if not relation or y >= 5:
            return []
        y += 1
        out = []
        parents = []
        if len(self.mObjects[50]): print "self.mObjects:", self.mObjects
        for prio in range(1, 101):
#            print "prio:", prio
            out += [ (prio, x) for x in self.objects(relation, 1, prio) ]
            # also check type-ancestors (base classes)
            for isa in list_IS_A:
                if str(isa) != str(relation):
                    try: parents += self.mObjects[prio][isa]
                    except: ''
        print "check parents...", parents
        for p in parents:
            if str(p) != str(self):
                out += p.getObjects(relation, y, first)
        return out

    # Get all the agents of a particular relation,
    # where this (self) is the object.  These are cumulative.
    def getAgents(self,relation, y = 1, first = ""):
        if id == first:
            return []
        if not len(first):
            first = str(self)

        if not relation or y >= 5:
            return []
        y += 1
        out = []
        parents = []
        for prio in range(1, 101):
            out += [ (prio, x) for x in self.agents(relation, 1, prio) ]
            # also check type-ancestors (base classes)
            for isa in list_IS_A:
                if str(isa) != str(relation):
                    try: parents += self.mObjects[prio][isa]
                    except: ''
            for p in parents:
                if str(p) != str(self):
                    out += p.getAgents(relation, y, first)
        return out

anything = Entity("_")
nothing = Entity("nothing")
nouns = { "nothing" : nothing, "_" : anything }
verbs = {}
for isa in list_IS_A:
    verbs[str(isa)] = isa

def getObjects(sub, _verb):
    r = acc(nouns, sub)
    if not r:
        return []
    ret = []
    arr = verb_synonyms(_verb)
    u = 0
    for verb in arr:
        u += 1
        ret += r.getObjects(acc(verbs, verb))
    ret = [ (rr[0], str(rr[1])) for rr in ret ]
#    print "ret:", ret
    return ret
def getAgents(sub, _verb):
    r = acc(nouns, sub)
    if not r:
        return []
    ret = []
    arr = verb_synonyms(_verb)
    u = 0
    for verb in arr:
        u += 1
        ret += r.getAgents(acc(verbs, verb))
    return [ (rr[0], str(rr[1])) for rr in ret ]
def get_advs(sub, _verb):
    r = acc(nouns, sub)
    if not r:
        return []
    ret = []
    arr = verb_synonyms(_verb)
    u = 0
    for verb in arr:
        u += 1
        p = r.get_advs(acc(verbs, verb))
        ret += p
    return [ str(rr) for rr in ret ]
def is_true_impl(sub, _verb, obj, prio = 50):
    arr = verb_synonyms(_verb)
    u = 0
    for verb in arr:
        u += 1
        r = acc(verbs, verb)
        if r:
            r = r(acc(nouns, sub), acc(nouns, obj), prio)
            if r:
                return r
    return False
def get_list_subs_impl(n):
    r = acc(nouns, n)
    if not r:
        return {}
    r = r.get_list_subs()
    return r
